# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.CivicInfo.V2.Model.Channel do
  @moduledoc """
  A social media or web channel for a candidate.

  ## Attributes

  *   `id` (*type:* `String.t`, *default:* `nil`) - The unique public identifier for the candidate's channel.
  *   `type` (*type:* `String.t`, *default:* `nil`) - The type of channel. The following is a list of types of channels, but is not exhaustive. More channel types may be added at a later time. One of: GooglePlus, YouTube, Facebook, Twitter
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :id => String.t(),
          :type => String.t()
        }

  field(:id)
  field(:type)
end

defimpl Poison.Decoder, for: GoogleApi.CivicInfo.V2.Model.Channel do
  def decode(value, options) do
    GoogleApi.CivicInfo.V2.Model.Channel.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.CivicInfo.V2.Model.Channel do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
