# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.CivicInfo.V2.Model.DivisionSearchResponse do
  @moduledoc """
  The result of a division search query.

  ## Attributes

  *   `kind` (*type:* `String.t`, *default:* `civicinfo#divisionSearchResponse`) - Identifies what kind of resource this is. Value: the fixed string "civicinfo#divisionSearchResponse".
  *   `results` (*type:* `list(GoogleApi.CivicInfo.V2.Model.DivisionSearchResult.t)`, *default:* `nil`) - 
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :kind => String.t(),
          :results => list(GoogleApi.CivicInfo.V2.Model.DivisionSearchResult.t())
        }

  field(:kind)
  field(:results, as: GoogleApi.CivicInfo.V2.Model.DivisionSearchResult, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.CivicInfo.V2.Model.DivisionSearchResponse do
  def decode(value, options) do
    GoogleApi.CivicInfo.V2.Model.DivisionSearchResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.CivicInfo.V2.Model.DivisionSearchResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
