# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.CivicInfo.V2.Model.DivisionSearchResult do
  @moduledoc """
  Represents a political geographic division that matches the requested query.

  ## Attributes

  *   `aliases` (*type:* `list(String.t)`, *default:* `nil`) - Other Open Civic Data identifiers that refer to the same division -- for example, those that refer to other political divisions whose boundaries are defined to be coterminous with this one. For example, ocd-division/country:us/state:wy will include an alias of ocd-division/country:us/state:wy/cd:1, since Wyoming has only one Congressional district.
  *   `name` (*type:* `String.t`, *default:* `nil`) - The name of the division.
  *   `ocdId` (*type:* `String.t`, *default:* `nil`) - The unique Open Civic Data identifier for this division
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :aliases => list(String.t()),
          :name => String.t(),
          :ocdId => String.t()
        }

  field(:aliases, type: :list)
  field(:name)
  field(:ocdId)
end

defimpl Poison.Decoder, for: GoogleApi.CivicInfo.V2.Model.DivisionSearchResult do
  def decode(value, options) do
    GoogleApi.CivicInfo.V2.Model.DivisionSearchResult.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.CivicInfo.V2.Model.DivisionSearchResult do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
